---
title: NDEFReader.scan()
slug: Web/API/NDEFReader/scan
tags:
  - NDEF
  - Reference
  - Web NFC
---
<p>{{Draft}}{{securecontext_header}}{{SeeCompatTable}}{{APIRef()}}</p>

<p><span class="seoSummary">The <code>scan()</code> method of {{DOMxRef("NDEFReader")}} interface reads NDEF records from compatible NFC devices, e.g., NDEF NFC tags.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var<em> readerPromise = NDEFReader</em>.scan(<em>options</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>
 <ul>
  <li><code>id</code> -- the match pattern for matching each {{DOMxRef("NDEFRecord.id")}}.</li>
  <li><code>recordType</code> -- the match pattern for matching each {{DOMxRef("NDEFRecord.recordType")}}.</li>
  <li><code>mediaType</code> -- the match pattern for matching each {{DOMxRef("NDEFRecord.mediaType")}}.</li>
  <li><code>signal</code> -- optional {{DOMxRef("AbortSignal")}} that allows to cancell this <code>scan()</code> operation.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{JSxRef("Promise")}} that resolves with <code>undefined</code> immediatelly after scheduling read operations for the NFC adapter.</p>

<h2 id="Exceptions">Exceptions</h2>

<p>This method doesn't throw true exceptions; instead, it rejects the returned promise, passing into it a {{domxref("DOMException")}} whose <code>name</code> is one of the following:</p>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>The scan operation was aborted with {{DOMxRef("AbortSignal")}} passed in options.</dd>
 <dt><code>NotAllowedError</code></dt>
 <dd>The permission for this operation was rejected.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>There is no NFC adapter compatible with Web NFC, or a connection can not be established.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td><a href="https://w3c.github.io/web-nfc/#dom-ndefreader-scan">Web NFC, scan()</a></td>
   <td>Draft</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.NDEFReader.scan")}}</p>
</div>
